/*
Add items to or delete items from an xml file  - 20071120
Copyright  2007 G6AUC

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
St, Fifth Floor, Boston, MA  02110-1301  USA
*/

var favoritesPath = system.widgetDataFolder + "/favorites.xml"; print('favoritesPath: ' + favoritesPath);

var gCategory = null;	// set by execCall() in menu.js
var gTitle    = null;
var gLink     = null;

function readFavorites(path)
{
    var i, dom, items, title, link, category;
    var dict = [];
    var text = filesystem.readFile(path);
    if (text)
    {
    	text = text.replace(/\<link\>\<\!\[CDATA\[/g, "<link>").replace(/\]\]\>\<\/link\>/g, "</link>");
    	text = text.replace(/\<link\>/g, "<link><![CDATA[").replace(/<\/link\>/g, "]]></link>");
    	
        try { dom = XMLDOM.parse( text ); } catch (e) { log('readFavorites: XMLDOM.parse error: ' + e); return null; }
        items = dom.evaluate( "rss/channel/item" );
        if (items !== null) {
        	log('readFavorites: There are ' + items.length + ' items.');
            for (i = 0; i < items.length; i += 1) {
                title     = items.item( i ).evaluate( "string( title )" );
                link      = items.item( i ).evaluate( "string( link )" );
                category  = items.item( i ).evaluate( "string( category )" );
                dict[i]   = {};
                dict[i].title    = title;
                dict[i].link     = link;
                dict[i].category = category;
            }
            return dict;
        } else { beep(); alert('readFavorites: There are no items.'); return null; }
    }
    else
    {
    	log('readFavorites: readFile failed');
    	beep();
    	alert('readFavorites: readFile failed'); return null;
    }
}

function listFavorites(dict)
{
	var i = 0;
	
	for (i = 0; i < dict.length; i += 1)
	{
		print('dict[' + i + ']:');
		print('title:    ' + dict[i].title);
		print('link:     ' + dict[i].link);
		print('category: ' + dict[i].category);
	}
}
	
function writeFavorites(path, dict)
{
	var i = 0, link;
	var head = '<?xml version="1.0" encoding="UTF-8"?>\n<rss version="2.0">\n<channel>\n';
	var tail = '</channel>\n</rss>\n';
	var body = "";
	for (i = 0; i < dict.length; i += 1)
	{
		body += '<item>\n';
		body += '<title>'    + dict[i].title    + '</title>\n';
		link = dict[i].link;
		if (link.indexOf("&") < 0) { body += '<link>' + link + '</link>\n'; }
		else              { body += '<link><![CDATA[' + link + ']]></link>\n'; }
		body += '<category>' + dict[i].category + '</category>\n';
		body += '</item>\n';
	}
	filesystem.writeFile(path, head + body + tail);
}

function orderFavorites(a, b)	// order by category and then by title
{
	if (a.category < b.category) { return -1; }
	if (a.category > b.category) { return  1; }
	if (a.title < b.title)  { return -1; }
	if (a.title > b.title)  { return  1; }
	return 0;
}

function findFavorite(dict, category, title, link)
{
	for (i = 0; i < dict.length; i += 1)
	{
		if ((dict[i].category == category) && (dict[i].title == title) && (dict[i].link == link)) { return i; }
	}
	return -1;
}

function addFavorite()
{
	if ((gCategory === null) || (gTitle === null) || (gLink === null))
	{
		beep(); alert("There is no current channel."); return;
	}
		
	var dict = readFavorites(favoritesPath);
	if (dict === null) { dict = []; }
	var entry = {};
	if (findFavorite(dict, gCategory, gTitle, gLink) < 0)
	{
		entry.category = gCategory;
		entry.title    = gTitle;
		entry.link     = gLink;
		dict.push(entry);
		dict.sort(orderFavorites);
		writeFavorites(favoritesPath, dict);
		log('favoritesMenu:addFavorite: ' + gTitle); favoritesMenu = makeMenu(favoritesURL,  'actionURL');	// make Favorites List menu
	}
	else
	{
		beep(); alert("The current channel [" + gCategory + " :: " + gTitle + "] is already in the favorites menu."); return;
	}
}

function delFavorite()
{
	if ((gCategory === null) || (gTitle === null) || (gLink === null))
	{
		beep(); alert("There is no current channel."); return;
	}

    var i, title, link, category;
	var dict = readFavorites(favoritesPath);
	if (dict === null) { dict = []; }
	for (i = 0; i < dict.length; i += 1)
	{
		title     = dict[i].title;
		link      = dict[i].link;
		category = dict[i].category;
		if ((title == gTitle) && (link == gLink) && (category == gCategory))
		{
			dict.splice(i,1);
			writeFavorites(favoritesPath, dict);
			log('favoritesMenu:delFavorite: ' + gTitle); favoritesMenu = makeMenu(favoritesURL,  'actionURL');	// make Favorites List menu
			return;
		}
	}
	beep(); alert("The current channel [" + gCategory + " :: " + gTitle + "] is not in the favorites menu."); return;
}
