/*  Make a Popup Menu from an RSS/XML Feed  - 20071120
Copyright  2006-2007 G6AUC

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 51 Franklin
St, Fifth Floor, Boston, MA  02110-1301  USA  */

function execCall()
{
	print('========== execCall =========');
	log(this.category + ' :: ' + this.title + ' :: ' + this.link);
	if (this.call == "setURL")
	{
		setURL(this.link);
	}
	else
	{
		gCategory = this.category;
		gTitle    = this.title;
		gLink     = this.link;
		actionURL(this.link);
	}
}

function makeSimpleMenu(location, call)
{
    var i, dom, items, title, link, category;
    var main = [];  var mainItem = null;
    var req = new XMLHttpRequest();
    req.open( "GET", location, false ); req.send();
    if ((req.status == 200) || (req.status === 0))
    {
        try { dom = XMLDOM.parse( req.responseText ); } catch (e) { log('makeSimpleMenu: XMLDOM.parse error: ' + e); return null; }
        items = dom.evaluate( "rss/channel/item" );
        if (items !== null) {
        	log('makeSimpleMenu: There are ' + items.length + ' items.');
            for (i = 0; i < items.length; i += 1) {
                title     = items.item( i ).evaluate( "string( title )" );
                link      = items.item( i ).evaluate( "string( link )" );
                category  = items.item( i ).evaluate( "string( category )" );
                mainItem = new MenuItem();
                mainItem.title     = title;
                mainItem.link      = link;
                mainItem.category  = category;
                mainItem.call      = call;
                mainItem.onSelect  = execCall;
                main.push(mainItem);
            }
            return main;
        } else { log('makeSimpleMenu: There are no items.'); return null; }
    } else {
    	log('makeSimpleMenu: XMLHttpRequest failed - http code: ' + req.status);
    	beep();
    	alert('makeSimpleMenu: XMLHttpRequest failed - http code: ' + req.status); return null;
    }
}

function makeMenu(location, call)
{
    var i, dom, items, title, link, category, text, req; var currentCategory = "";
    var main = [];  var mainItem = null; var subItem  = null; var reqType = "XMLHttpRequest";
    if (location == favoritesURL)
    {
		reqType = "readFile";
		text = filesystem.readFile(favoritesPath);
    	if (text)
    	{
    		text = text.replace(/\<link\>\<\!\[CDATA\[/g, "<link>").replace(/\]\]\>\<\/link\>/g, "</link>");
    		text = text.replace(/\<link\>/g, "<link><![CDATA[").replace(/<\/link\>/g, "]]></link>");
    	}
    }
    else
    {
    	req = new XMLHttpRequest();
    	req.open( "GET", location, false ); req.send();
    	if ((req.status == 200) || (req.status === 0))
    	{
    		text = req.responseText;
    	}
    	else { text = null; }
    }
    
    if (text)
    {
        try { dom = XMLDOM.parse( text ); } catch (e) { log('makeMenu: XMLDOM.parse error: ' + e); return null; }
        items = dom.evaluate( "rss/channel/item" );
        if (items !== null) {
        	log('makeMenu: There are ' + items.length + ' items.');
            for (i = 0; i < items.length; i += 1) {
                title = items.item( i ).evaluate( "string( title )" );
                link  = items.item( i ).evaluate( "string( link )" );
                category  = items.item( i ).evaluate( "string( category )" );
                if (category != currentCategory) {
                    currentCategory = category;
                    mainItem = new MenuItem();
                 	mainItem.title     = category;
                    main.push(mainItem);
                }
                subItem = new MenuItem();
                subItem.title     = title;
                subItem.link      = link;
                subItem.category  = category;
                subItem.call      = call;
                subItem.onSelect  = execCall;
                mainItem.appendChild(subItem);
            }
            return main;
        } else { beep(); alert('makeMenu: There are no items.'); return null; }
    }
    else
    {
    	beep();
    	if (reqType == "XMLHttpRequest")
    	{
    		  log('makeMenu: XMLHttpRequest failed - http code: ' + req.status);
    		alert('makeMenu: XMLHttpRequest failed - http code: ' + req.status);
    	}
    	else
    	{
    		  log('makeMenu: read favorites failed');
    		alert('makeMenu: read favorites failed');
    	}
    	return null;
    }
}
/*  End of Make a Popup Menu from an RSS/XML Feed */

function myPopupMenuMain()
{
	if (mainMenu !== null)	{ popupMenu( mainMenu, system.event.hOffset, system.event.vOffset ); }
}

function myPopupMenuChannels()
{
	if (channelsMenu !== null) { popupMenu( channelsMenu, system.event.hOffset, system.event.vOffset ); }
}

function myPopupMenuFavorites()
{
	if (favoritesMenu !== null) { popupMenu( favoritesMenu, system.event.hOffset, system.event.vOffset ); }
}

function setURL(link)
{
	log('setURL called with link: ' + link);
	channelsURL = link;
	channelsMenu = makeMenu(channelsURL, 'actionURL');
}

var exists = filesystem.itemExists(favoritesPath); print('favoritesPath exists: ' + exists);
if (!exists) { favoritesPath = widget.extractFile("Resources/favorites.xml"); }

var mainMenu      = null;
var channelsMenu  = null;
var favoritesMenu = null;

var mainURL      = "http://www.letshost4u.ws/widget/main.xml";
var channelsURL  = "http://www.letshost4u.ws/widget/news.xml";
var favoritesURL = "file:///" + favoritesPath;
print('favoritesPath: ' + favoritesPath);
print('favoritesURL:  ' + favoritesURL);

log('making favoritesMenu:'); favoritesMenu = makeMenu(favoritesURL,  'actionURL');	// make Favorites List menu
log('making channelsMenu:');  channelsMenu  = makeMenu(channelsURL,   'actionURL');	// make default Channel List menu
log('making mainMenu:'); 	  mainMenu      = makeSimpleMenu(mainURL, 'setURL');	// make Category List menu
